cdac.medinfo.sdk.hl7282.baselibs.segments

## Class PCR

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.PCR

- All Implemented Interfaces:
    ISegment

      public class PCR
      extends Segment

  PCR - Possible Causal Relationship Segment.

  The PCR segment is used to communicate a potential or suspected relationship between a product (drug or device) or test and an event with detrimental effect on a patient. This segment identifies a potential causal relationship between the product identified in this segment and the event identified in the PEO segment.

  Represents an HL7 PCR message segment. This segment has the following fields:

  PCR-1: Implicated Product (CWE)Required
  PCR-2: Generic Product (IS)Optional
  PCR-3: Product Class (CWE)Optional
  PCR-4: Total Duration Of Therapy (CQ)Optional
  PCR-5: Product Manufacture Date (DTM)Optional
  PCR-6: Product Expiration Date (DTM)Optional
  PCR-7: Product Implantation Date (DTM)Optional
  PCR-8: Product Explantation Date (DTM)Optional
  PCR-9: Single Use Device (CWE)Optional
  PCR-10: Indication For Product Use (CWE)Optional
  PCR-11: Product Problem (CWE)Optional
  PCR-12: Product Serial/Lot Number (ST)Optional
  PCR-13: Product Available For Inspection (CWE)Optional
  PCR-14: Product Evaluation Performed (CWE)Optional
  PCR-15: Product Evaluation Status (CWE)Optional
  PCR-16: Product Evaluation Results (CWE)Optional
  PCR-17: Evaluated Product Source (ID)Optional
  PCR-18: Date Product Returned To Manufacturer (DTM)Optional
  PCR-19: Device Operator Qualifications (ID)Optional
  PCR-20: Relatedness Assessment (ID)Optional
  PCR-21: Action Taken In Response To The Event (ID)Optional
  PCR-22: Event Causality Observations (ID)Optional
  PCR-23: Indirect Exposure Mechanism (ID)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PCR()` Constructs the PCR segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addActionTakenInResponseToTheEvent(ID objactionTakenInResponseToTheEvent)` Add the Action Taken In Response To The Event.
    `void` | `addActionTakenInResponseToTheEvent(java.lang.String strActionTakenInResponseToTheEvent)` Add the Action Taken In Response To The Event.
    `void` | `addEventCausalityObservations(ID objeventCausalityObservations)` Add the Event Causality Observations.
    `void` | `addEventCausalityObservations(java.lang.String strEventCausalityObservations)` Add the Event Causality Observations.
    `void` | `addIndirectExposureMechanism(ID objindirectExposureMechanism)` Add the Indirect Exposure Mechanism.
    `void` | `addIndirectExposureMechanism(java.lang.String strIndirectExposureMechanism)` Add the Indirect Exposure Mechanism.
    `void` | `addProductSerialLotNumber(ST objproductSerialLotNumber)` Add the Product Serial Lot Number.
    `void` | `addProductSerialLotNumber(java.lang.String strProductSerialLotNumber)` Add the Product Serial Lot Number.
    `ISingleCollection<ID>` | `getActionTakenInResponseToTheEvent()` Retrieves the Action Taken In Response To The Event.
    `DTM` | `getDateProductReturnedToManufacturer()` Retrieves the Date Product Returned To Manufacturer.
    `ID` | `getDeviceOperatorQualifications()` Retrieves the Device Operator Qualifications.
    `ID` | `getEvaluatedProductSource()` Retrieves the Evaluated Product Source.
    `ISingleCollection<ID>` | `getEventCausalityObservations()` Retrieves the Event Causality Observations.
    `IS` | `getGenericProduct()` Retrieves the Generic Product.
    `CWE` | `getImplicatedProduct()` Retrieves the Implicated Product.
    `CWE` | `getIndicationForProductUse()` Retrieves the Indication For Product Use.
    `ISingleCollection<ID>` | `getIndirectExposureMechanism()` Retrieves the Indirect Exposure Mechanism.
    `CWE` | `getProductAvailableForInspection()` Retrieves the Product Available For Inspection.
    `CWE` | `getProductClass()` Retrieves the Product Class.
    `CWE` | `getProductEvaluationPerformed()` Retrieves the Product Evaluation Performed.
    `CWE` | `getProductEvaluationResults()` Retrieves the Product Evaluation Results.
    `CWE` | `getProductEvaluationStatus()` Retrieves the Product Evaluation Status.
    `DTM` | `getProductExpirationDate()` Retrieves the Product Expiration Date.
    `DTM` | `getProductExplantationDate()` Retrieves the Product Explantation Date.
    `DTM` | `getProductImplantationDate()` Retrieves the Product Implantation Date.
    `DTM` | `getProductManufactureDate()` Retrieves the Product Manufacture Date.
    `CWE` | `getProductProblem()` Retrieves the Product Problem.
    `ISingleCollection<ST>` | `getProductSerialLotNumber()` Retrieves the Product Serial Lot Number.
    `ID` | `getRelatednessAssessment()` Retrieves the Relatedness Assessment.
    `CWE` | `getSingleUseDevice()` Retrieves the Single Use Device.
    `CQ` | `getTotalDurationOfTherapy()` Retrieves the Total Duration Of Therapy.
    `void` | `setActionTakenInResponseToTheEvent(ISingleCollection<ID> objactionTakenInResponseToTheEventList)` Set the Action Taken In Response To The Event.
    `void` | `setDateProductReturnedToManufacturer(DTM objdateProductReturnedToManufacturer)` Set the Date Product Returned To Manufacturer.
    `void` | `setDateProductReturnedToManufacturer(java.lang.String strTime)` Set the Date Product Returned To Manufacturer.
    `void` | `setDeviceOperatorQualifications(ID objdeviceOperatorQualifications)` Set the Device Operator Qualifications.
    `void` | `setDeviceOperatorQualifications(java.lang.String strDeviceOperatorQualifications)` Set the Device Operator Qualifications.
    `void` | `setEvaluatedProductSource(ID objevaluatedProductSource)` Set the Evaluated Product Source.
    `void` | `setEvaluatedProductSource(java.lang.String strEvaluatedProductSource)` Set the Evaluated Product Source.
    `void` | `setEventCausalityObservations(ISingleCollection<ID> objeventCausalityObservationsList)` Set the Event Causality Observations.
    `void` | `setGenericProduct(IS objgenericProduct)` Set the Generic Product.
    `void` | `setGenericProduct(java.lang.String strGenericProduct)` Set the Generic Product.
    `void` | `setImplicatedProduct(CWE objimplicatedProduct)` Set the Implicated Product.
    `void` | `setImplicatedProduct(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Implicated Product.
    `void` | `setIndicationForProductUse(CWE objindicationForProductUse)` Set the Indication For Product Use.
    `void` | `setIndicationForProductUse(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Indication For Product Use.
    `void` | `setIndirectExposureMechanism(ISingleCollection<ID> objindirectExposureMechanismList)` Set the Indirect Exposure Mechanism.
    `void` | `setProductAvailableForInspection(CWE objproductAvailableForInspection)` Set the Product Available For Inspection.
    `void` | `setProductAvailableForInspection(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Product Available For Inspection.
    `void` | `setProductClass(CWE objproductClass)` Set the Product Class.
    `void` | `setProductClass(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Product Class.
    `void` | `setProductEvaluationPerformed(CWE objproductEvaluationPerformed)` Set the Product Evaluation Performed.
    `void` | `setProductEvaluationPerformed(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Product Evaluation Performed.
    `void` | `setProductEvaluationResults(CWE objproductEvaluationResults)` Set the Product Evaluation Results.
    `void` | `setProductEvaluationResults(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Product Evaluation Results.
    `void` | `setProductEvaluationStatus(CWE objproductEvaluationStatus)` Set the Product Evaluation Status.
    `void` | `setProductEvaluationStatus(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Product Evaluation Status.
    `void` | `setProductExpirationDate(DTM objproductExpirationDate)` Set the Product Expiration Date.
    `void` | `setProductExpirationDate(java.lang.String strTime)` Set the Product Expiration Date.
    `void` | `setProductExplantationDate(DTM objproductExplantationDate)` Set the Product Explanation Date.
    `void` | `setProductExplantationDate(java.lang.String strTime)` Set the Product Explanation Date.
    `void` | `setProductImplantationDate(DTM objproductImplantationDate)` Set the Product Implantation Date.
    `void` | `setProductImplantationDate(java.lang.String strTime)` Set the Product Implantation Date.
    `void` | `setProductManufactureDate(DTM objproductManufactureDate)` Set the Product Manufacture Date.
    `void` | `setProductManufactureDate(java.lang.String strTime)` Set the Product Manufacture Date.
    `void` | `setProductProblem(CWE objproductProblem)` Set the Product Problem.
    `void` | `setProductProblem(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Product Problem.
    `void` | `setProductSerialLotNumber(ISingleCollection<ST> objproductSerialLotNumberList)` Set the Product Serial Lot Number.
    `void` | `setRelatednessAssessment(ID objrelatednessAssessment)` Set the Relatedness Assessment.
    `void` | `setRelatednessAssessment(java.lang.String strRelatednessAssessment)` Set the Relatedness Assessment.
    `void` | `setSingleUseDevice(CWE objsingleUseDevice)` Set the Single Use Device.
    `void` | `setSingleUseDevice(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Single Use Device.
    `void` | `setTotalDurationOfTherapy(CQ objtotalDurationOfTherapy)` Set the Total Duration Of Therapy.
    `void` | `setTotalDurationOfTherapy(java.lang.String strQuantity, CWE objUnits)` Set the Total Duration Of Therapy.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PCR

          public PCR()

      Constructs the PCR segment.

  - ### Method Detail

    - #### getActionTakenInResponseToTheEvent

          public ISingleCollection<ID> getActionTakenInResponseToTheEvent()

      Retrieves the Action Taken In Response To The Event. This field indicates the action taken as a result of the event.
      Returns:
        ISingleCollection - actionTakenInResponseToTheEvent

    - #### getDateProductReturnedToManufacturer

          public DTM getDateProductReturnedToManufacturer()

      Retrieves the Date Product Returned To Manufacturer. This field contains the date it is returned may be reported.
      Returns:
        DTM - dateProductReturnedToManufacturer

    - #### getDeviceOperatorQualifications

          public ID getDeviceOperatorQualifications()

      Retrieves the Device Operator Qualifications. This field identify the qualification of the person operating the device when the event occurred.
      Returns:
        ID - deviceOperatorQualifications

    - #### getEvaluatedProductSource

          public ID getEvaluatedProductSource()

      Retrieves the Evaluated Product Source. This field contains the source of the product evaluated.
      Returns:
        ID - evaluatedProductSource

    - #### getEventCausalityObservations

          public ISingleCollection<ID> getEventCausalityObservations()

      Retrieves the Event Causality Observations. This field contains observations made about the event which may bear on causality.
      Returns:
        ISingleCollection - eventCausalityObservations

    - #### getGenericProduct

          public IS getGenericProduct()

      Retrieves the Generic Product. This field indicates whether the product used is a generic or a branded product.
      Returns:
        IS - genericProduct

    - #### getImplicatedProduct

          public CWE getImplicatedProduct()

      Retrieves the Implicated Product. This field contains the coded identity of the product (drug, device, etc.) which is possibly causally related to the event.
      Returns:
        CWE - implicatedProduct

    - #### getIndicationForProductUse

          public CWE getIndicationForProductUse()

      Retrieves the Indication For Product Use. This field contains coded representation of the problem or diagnosis for which the product is used.
      Returns:
        CWE - indicationForProductUse

    - #### getIndirectExposureMechanism

          public ISingleCollection<ID> getIndirectExposureMechanism()

      Retrieves the Indirect Exposure Mechanism.
      Returns:
        ISingleCollection - indirectExposureMechanism

    - #### getProductAvailableForInspection

          public CWE getProductAvailableForInspection()

      Retrieves the Product Available For Inspection. This field indicates that the product is available for analysis.
      Returns:
        CWE - productAvailableForInspection

    - #### getProductClass

          public CWE getProductClass()

      Retrieves the Product Class. This field contains the coded classification of the implicated product.
      Returns:
        CWE - productClass

    - #### getProductEvaluationPerformed

          public CWE getProductEvaluationPerformed()

      Retrieves the Product Evaluation Performed. This field indicates the type of product evaluation performed.
      Returns:
        CWE - productEvaluationPerformed

    - #### getProductEvaluationResults

          public CWE getProductEvaluationResults()

      Retrieves the Product Evaluation Results. This field contains the results of the product evaluation.
      Returns:
        CWE - productEvaluationResults

    - #### getProductEvaluationStatus

          public CWE getProductEvaluationStatus()

      Retrieves the Product Evaluation Status. This field identify the status of product evaluation.
      Returns:
        CWE - productEvaluationStatus

    - #### getProductExpirationDate

          public DTM getProductExpirationDate()

      Retrieves the Product Expiration Date. This field contains the expiration date indicated on the product packaging.
      Returns:
        DTM - productExpirationDate

    - #### getProductExplantationDate

          public DTM getProductExplantationDate()

      Retrieves the Product Explantation Date. This field identify the date that product is removed.
      Returns:
        DTM - productExplantationDate

    - #### getProductImplantationDate

          public DTM getProductImplantationDate()

      Retrieves the Product Implantation Date. This field identify the date that device is implanted.
      Returns:
        DTM - productImplantationDate

    - #### getProductManufactureDate

          public DTM getProductManufactureDate()

      Retrieves the Product Manufacture Date. This field indicates the date the product is manufactured.
      Returns:
        DTM - productManufactureDate

    - #### getProductProblem

          public CWE getProductProblem()

      Retrieves the Product Problem. This product problem would exist if a product malfunction could lead to death or serious injury.
      Returns:
        CWE - productProblem

    - #### getProductSerialLotNumber

          public ISingleCollection<ST> getProductSerialLotNumber()

      Retrieves the Product Serial Lot Number. This field is an alphanumeric descriptor which identify the specific item or lot of drug.
      Returns:
        ISingleCollection - productSerialLotNumber

    - #### getRelatednessAssessment

          public ID getRelatednessAssessment()

      Retrieves the Relatedness Assessment. This field represents the assessment of relatedness of the product to the event.
      Returns:
        ID - relatednessAssessment

    - #### getSingleUseDevice

          public CWE getSingleUseDevice()

      Retrieves the Single Use Device. This field indicates whether the product is designed for a single use or not.
      Returns:
        CWE - singleUseDevice

    - #### getTotalDurationOfTherapy

          public CQ getTotalDurationOfTherapy()

      Retrieves the Total Duration Of Therapy. This field represents the total duration of therapy with product listed.
      Returns:
        CQ - totalDurationOfTherapy

    - #### addActionTakenInResponseToTheEvent

          public void addActionTakenInResponseToTheEvent(java.lang.String strActionTakenInResponseToTheEvent)

      Add the Action Taken In Response To The Event. This field indicates the action taken as a result of the event.
      Parameters:
        `strActionTakenInResponseToTheEvent` - This field contains the String Value of Action Taken In Response To The Event

    - #### addActionTakenInResponseToTheEvent

          public void addActionTakenInResponseToTheEvent(ID objactionTakenInResponseToTheEvent)

      Add the Action Taken In Response To The Event. This field indicates the action taken as a result of the event.
      Parameters:
        `objactionTakenInResponseToTheEvent` - Object of Action Taken In Response To The Event.

    - #### setActionTakenInResponseToTheEvent

          public void setActionTakenInResponseToTheEvent(ISingleCollection<ID> objactionTakenInResponseToTheEventList)

      Set the Action Taken In Response To The Event. This field indicates the action taken as a result of the event.
      Parameters:
        `objactionTakenInResponseToTheEventList` - List of Action Taken In Response To The Event.

    - #### setDateProductReturnedToManufacturer

          public void setDateProductReturnedToManufacturer(java.lang.String strTime)

      Set the Date Product Returned To Manufacturer. This field contains the date it is returned may be reported.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setDateProductReturnedToManufacturer

          public void setDateProductReturnedToManufacturer(DTM objdateProductReturnedToManufacturer)

      Set the Date Product Returned To Manufacturer. This field contains the date it is returned may be reported.
      Parameters:
        `objdateProductReturnedToManufacturer` - Object of Date Product Returned To Manufacturer.

    - #### setDeviceOperatorQualifications

          public void setDeviceOperatorQualifications(java.lang.String strDeviceOperatorQualifications)

      Set the Device Operator Qualifications. This field identify the qualification of the person operating the device when the event occurred.
      Parameters:
        `strDeviceOperatorQualifications` - This field contains the String Value of Device Operator Qualifications

    - #### setDeviceOperatorQualifications

          public void setDeviceOperatorQualifications(ID objdeviceOperatorQualifications)

      Set the Device Operator Qualifications. This field identify the qualification of the person operating the device when the event occurred.
      Parameters:
        `objdeviceOperatorQualifications` - Object of Device Operator Qualifications.

    - #### setEvaluatedProductSource

          public void setEvaluatedProductSource(java.lang.String strEvaluatedProductSource)

      Set the Evaluated Product Source. This field contains the source of the product evaluated.
      Parameters:
        `strEvaluatedProductSource` - This field contains the String Value of Evaluated Product Source

    - #### setEvaluatedProductSource

          public void setEvaluatedProductSource(ID objevaluatedProductSource)

      Set the Evaluated Product Source. This field contains the source of the product evaluated.
      Parameters:
        `objevaluatedProductSource` - Object of Evaluated Product Source.

    - #### addEventCausalityObservations

          public void addEventCausalityObservations(java.lang.String strEventCausalityObservations)

      Add the Event Causality Observations. This field contains observations made about the event which may bear on causality.
      Parameters:
        `strEventCausalityObservations` - This field contains the String Value of Event Causality Observations

    - #### addEventCausalityObservations

          public void addEventCausalityObservations(ID objeventCausalityObservations)

      Add the Event Causality Observations. This field contains observations made about the event which may bear on causality.
      Parameters:
        `objeventCausalityObservations` - Object of Event Causality Observations.

    - #### setEventCausalityObservations

          public void setEventCausalityObservations(ISingleCollection<ID> objeventCausalityObservationsList)

      Set the Event Causality Observations. This field contains observations made about the event which may bear on causality.
      Parameters:
        `objeventCausalityObservationsList` - List of Event Causality Observations.

    - #### setGenericProduct

          public void setGenericProduct(java.lang.String strGenericProduct)

      Set the Generic Product. This field indicates whether the product used is a generic or a branded product.
      Parameters:
        `strGenericProduct` - This field contains the String Value of Generic Product

    - #### setGenericProduct

          public void setGenericProduct(IS objgenericProduct)

      Set the Generic Product. This field indicates whether the product used is a generic or a branded product.
      Parameters:
        `objgenericProduct` - Object of Generic Product.

    - #### setImplicatedProduct

          public void setImplicatedProduct(java.lang.String strIdentifier,
                                  java.lang.String strText,
                                  java.lang.String strNameOfCodingSystem,
                                  java.lang.String strAlternateIdentifier,
                                  java.lang.String strAlternateText,
                                  java.lang.String strNameOfAlternateCodingSystem,
                                  java.lang.String strCodingSystemVersionID,
                                  java.lang.String strAlternateCodingSystemVersionId,
                                  java.lang.String strOriginalText,
                                  java.lang.String strSecondAlternateIdentifier,
                                  java.lang.String strSecondAlternateText,
                                  java.lang.String strNameofSecondAlternateCodingSystem,
                                  java.lang.String strSecondAlternateCodingSystemVersionID,
                                  java.lang.String strCodingSystemOID,
                                  java.lang.String strValueSetOID,
                                  java.lang.String strValueSetVersionID,
                                  java.lang.String strAlternateCodingSystemOID,
                                  java.lang.String strAlternateValueSetOID,
                                  java.lang.String strAlternateValueSetVersionID,
                                  java.lang.String strSecondAlternateCodingSystemOID,
                                  java.lang.String strSecondAlternateValueSetOID,
                                  java.lang.String strSecondAlternateValueSetVersionID)

      Set the Implicated Product. This field contains the coded identity of the product (drug, device, etc.) which is possibly causally related to the event.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setImplicatedProduct

          public void setImplicatedProduct(CWE objimplicatedProduct)

      Set the Implicated Product. This field contains the coded identity of the product (drug, device, etc.) which is possibly causally related to the event.
      Parameters:
        `objimplicatedProduct` - Object of Implicated Product.

    - #### setIndicationForProductUse

          public void setIndicationForProductUse(java.lang.String strIdentifier,
                                        java.lang.String strText,
                                        java.lang.String strNameOfCodingSystem,
                                        java.lang.String strAlternateIdentifier,
                                        java.lang.String strAlternateText,
                                        java.lang.String strNameOfAlternateCodingSystem,
                                        java.lang.String strCodingSystemVersionID,
                                        java.lang.String strAlternateCodingSystemVersionId,
                                        java.lang.String strOriginalText,
                                        java.lang.String strSecondAlternateIdentifier,
                                        java.lang.String strSecondAlternateText,
                                        java.lang.String strNameofSecondAlternateCodingSystem,
                                        java.lang.String strSecondAlternateCodingSystemVersionID,
                                        java.lang.String strCodingSystemOID,
                                        java.lang.String strValueSetOID,
                                        java.lang.String strValueSetVersionID,
                                        java.lang.String strAlternateCodingSystemOID,
                                        java.lang.String strAlternateValueSetOID,
                                        java.lang.String strAlternateValueSetVersionID,
                                        java.lang.String strSecondAlternateCodingSystemOID,
                                        java.lang.String strSecondAlternateValueSetOID,
                                        java.lang.String strSecondAlternateValueSetVersionID)

      Set the Indication For Product Use. This field contains coded representation of the problem or diagnosis for which the product is used.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setIndicationForProductUse

          public void setIndicationForProductUse(CWE objindicationForProductUse)

      Set the Indication For Product Use. This field contains coded representation of the problem or diagnosis for which the product is used.
      Parameters:
        `objindicationForProductUse` - Object of Indication For Product Use.

    - #### addIndirectExposureMechanism

          public void addIndirectExposureMechanism(java.lang.String strIndirectExposureMechanism)

      Add the Indirect Exposure Mechanism.
      Parameters:
        `strIndirectExposureMechanism` - This field contains the String Value of Indirect Exposure Mechanism

    - #### addIndirectExposureMechanism

          public void addIndirectExposureMechanism(ID objindirectExposureMechanism)

      Add the Indirect Exposure Mechanism.
      Parameters:
        `objindirectExposureMechanism` - Object of Indirect Exposure Mechanism.

    - #### setIndirectExposureMechanism

          public void setIndirectExposureMechanism(ISingleCollection<ID> objindirectExposureMechanismList)

      Set the Indirect Exposure Mechanism.
      Parameters:
        `objindirectExposureMechanismList` - List of Indirect Exposure Mechanism.

    - #### setProductAvailableForInspection

          public void setProductAvailableForInspection(java.lang.String strIdentifier,
                                              java.lang.String strText,
                                              java.lang.String strNameOfCodingSystem,
                                              java.lang.String strAlternateIdentifier,
                                              java.lang.String strAlternateText,
                                              java.lang.String strNameOfAlternateCodingSystem,
                                              java.lang.String strCodingSystemVersionID,
                                              java.lang.String strAlternateCodingSystemVersionId,
                                              java.lang.String strOriginalText,
                                              java.lang.String strSecondAlternateIdentifier,
                                              java.lang.String strSecondAlternateText,
                                              java.lang.String strNameofSecondAlternateCodingSystem,
                                              java.lang.String strSecondAlternateCodingSystemVersionID,
                                              java.lang.String strCodingSystemOID,
                                              java.lang.String strValueSetOID,
                                              java.lang.String strValueSetVersionID,
                                              java.lang.String strAlternateCodingSystemOID,
                                              java.lang.String strAlternateValueSetOID,
                                              java.lang.String strAlternateValueSetVersionID,
                                              java.lang.String strSecondAlternateCodingSystemOID,
                                              java.lang.String strSecondAlternateValueSetOID,
                                              java.lang.String strSecondAlternateValueSetVersionID)

      Set the Product Available For Inspection. This field indicates that the product is available for analysis.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setProductAvailableForInspection

          public void setProductAvailableForInspection(CWE objproductAvailableForInspection)

      Set the Product Available For Inspection. This field indicates that the product is available for analysis.
      Parameters:
        `objproductAvailableForInspection` - Object of Product Available For Inspection.

    - #### setProductClass

          public void setProductClass(java.lang.String strIdentifier,
                             java.lang.String strText,
                             java.lang.String strNameOfCodingSystem,
                             java.lang.String strAlternateIdentifier,
                             java.lang.String strAlternateText,
                             java.lang.String strNameOfAlternateCodingSystem,
                             java.lang.String strCodingSystemVersionID,
                             java.lang.String strAlternateCodingSystemVersionId,
                             java.lang.String strOriginalText,
                             java.lang.String strSecondAlternateIdentifier,
                             java.lang.String strSecondAlternateText,
                             java.lang.String strNameofSecondAlternateCodingSystem,
                             java.lang.String strSecondAlternateCodingSystemVersionID,
                             java.lang.String strCodingSystemOID,
                             java.lang.String strValueSetOID,
                             java.lang.String strValueSetVersionID,
                             java.lang.String strAlternateCodingSystemOID,
                             java.lang.String strAlternateValueSetOID,
                             java.lang.String strAlternateValueSetVersionID,
                             java.lang.String strSecondAlternateCodingSystemOID,
                             java.lang.String strSecondAlternateValueSetOID,
                             java.lang.String strSecondAlternateValueSetVersionID)

      Set the Product Class. This field contains the coded classification of the implicated product.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setProductClass

          public void setProductClass(CWE objproductClass)

      Set the Product Class. This field contains the coded classification of the implicated product.
      Parameters:
        `objproductClass` - Object of Product Class.

    - #### setProductEvaluationPerformed

          public void setProductEvaluationPerformed(java.lang.String strIdentifier,
                                           java.lang.String strText,
                                           java.lang.String strNameOfCodingSystem,
                                           java.lang.String strAlternateIdentifier,
                                           java.lang.String strAlternateText,
                                           java.lang.String strNameOfAlternateCodingSystem,
                                           java.lang.String strCodingSystemVersionID,
                                           java.lang.String strAlternateCodingSystemVersionId,
                                           java.lang.String strOriginalText,
                                           java.lang.String strSecondAlternateIdentifier,
                                           java.lang.String strSecondAlternateText,
                                           java.lang.String strNameofSecondAlternateCodingSystem,
                                           java.lang.String strSecondAlternateCodingSystemVersionID,
                                           java.lang.String strCodingSystemOID,
                                           java.lang.String strValueSetOID,
                                           java.lang.String strValueSetVersionID,
                                           java.lang.String strAlternateCodingSystemOID,
                                           java.lang.String strAlternateValueSetOID,
                                           java.lang.String strAlternateValueSetVersionID,
                                           java.lang.String strSecondAlternateCodingSystemOID,
                                           java.lang.String strSecondAlternateValueSetOID,
                                           java.lang.String strSecondAlternateValueSetVersionID)

      Set the Product Evaluation Performed. This field indicates the type of product evaluation performed.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setProductEvaluationPerformed

          public void setProductEvaluationPerformed(CWE objproductEvaluationPerformed)

      Set the Product Evaluation Performed. This field indicates the type of product evaluation performed.
      Parameters:
        `objproductEvaluationPerformed` - Object of Product Evaluation Performed.

    - #### setProductEvaluationResults

          public void setProductEvaluationResults(java.lang.String strIdentifier,
                                         java.lang.String strText,
                                         java.lang.String strNameOfCodingSystem,
                                         java.lang.String strAlternateIdentifier,
                                         java.lang.String strAlternateText,
                                         java.lang.String strNameOfAlternateCodingSystem,
                                         java.lang.String strCodingSystemVersionID,
                                         java.lang.String strAlternateCodingSystemVersionId,
                                         java.lang.String strOriginalText,
                                         java.lang.String strSecondAlternateIdentifier,
                                         java.lang.String strSecondAlternateText,
                                         java.lang.String strNameofSecondAlternateCodingSystem,
                                         java.lang.String strSecondAlternateCodingSystemVersionID,
                                         java.lang.String strCodingSystemOID,
                                         java.lang.String strValueSetOID,
                                         java.lang.String strValueSetVersionID,
                                         java.lang.String strAlternateCodingSystemOID,
                                         java.lang.String strAlternateValueSetOID,
                                         java.lang.String strAlternateValueSetVersionID,
                                         java.lang.String strSecondAlternateCodingSystemOID,
                                         java.lang.String strSecondAlternateValueSetOID,
                                         java.lang.String strSecondAlternateValueSetVersionID)

      Set the Product Evaluation Results. This field contains the results of the product evaluation.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setProductEvaluationResults

          public void setProductEvaluationResults(CWE objproductEvaluationResults)

      Set the Product Evaluation Results. This field contains the results of the product evaluation.
      Parameters:
        `objproductEvaluationResults` - Object of Product Evaluation Results.

    - #### setProductEvaluationStatus

          public void setProductEvaluationStatus(java.lang.String strIdentifier,
                                        java.lang.String strText,
                                        java.lang.String strNameOfCodingSystem,
                                        java.lang.String strAlternateIdentifier,
                                        java.lang.String strAlternateText,
                                        java.lang.String strNameOfAlternateCodingSystem,
                                        java.lang.String strCodingSystemVersionID,
                                        java.lang.String strAlternateCodingSystemVersionId,
                                        java.lang.String strOriginalText,
                                        java.lang.String strSecondAlternateIdentifier,
                                        java.lang.String strSecondAlternateText,
                                        java.lang.String strNameofSecondAlternateCodingSystem,
                                        java.lang.String strSecondAlternateCodingSystemVersionID,
                                        java.lang.String strCodingSystemOID,
                                        java.lang.String strValueSetOID,
                                        java.lang.String strValueSetVersionID,
                                        java.lang.String strAlternateCodingSystemOID,
                                        java.lang.String strAlternateValueSetOID,
                                        java.lang.String strAlternateValueSetVersionID,
                                        java.lang.String strSecondAlternateCodingSystemOID,
                                        java.lang.String strSecondAlternateValueSetOID,
                                        java.lang.String strSecondAlternateValueSetVersionID)

      Set the Product Evaluation Status. This field identify the status of product evaluation.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setProductEvaluationStatus

          public void setProductEvaluationStatus(CWE objproductEvaluationStatus)

      Set the Product Evaluation Status. This field identify the status of product evaluation.
      Parameters:
        `objproductEvaluationStatus` - Object of Product Evaluation Status.

    - #### setProductExpirationDate

          public void setProductExpirationDate(java.lang.String strTime)

      Set the Product Expiration Date. This field contains the expiration date indicated on the product packaging.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.
        `strDegreeOfPrecision` - The degree of precision of the time stamp .Suggested Values Y,L,D,H,M,S [Refer to HL7 Table 0529].

    - #### setProductExpirationDate

          public void setProductExpirationDate(DTM objproductExpirationDate)

      Set the Product Expiration Date. This field contains the expiration date indicated on the product packaging.
      Parameters:
        `objproductExpirationDate` - Object of Product Expiration Date.

    - #### setProductExplantationDate

          public void setProductExplantationDate(java.lang.String strTime)

      Set the Product Explanation Date. This field identify the date that product is removed.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setProductExplantationDate

          public void setProductExplantationDate(DTM objproductExplantationDate)

      Set the Product Explanation Date. This field identify the date that product is removed.
      Parameters:
        `objproductExplantationDate` - Object of Product Explanation Date.

    - #### setProductImplantationDate

          public void setProductImplantationDate(java.lang.String strTime)

      Set the Product Implantation Date. This field identify the date that device is implanted.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setProductImplantationDate

          public void setProductImplantationDate(DTM objproductImplantationDate)

      Set the Product Implantation Date. This field identify the date that device is implanted.
      Parameters:
        `objproductImplantationDate` - Object of Product Implantation Date.

    - #### setProductManufactureDate

          public void setProductManufactureDate(java.lang.String strTime)

      Set the Product Manufacture Date. This field indicates the date the product is manufactured.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setProductManufactureDate

          public void setProductManufactureDate(DTM objproductManufactureDate)

      Set the Product Manufacture Date. This field indicates the date the product is manufactured.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setProductProblem

          public void setProductProblem(java.lang.String strIdentifier,
                               java.lang.String strText,
                               java.lang.String strNameOfCodingSystem,
                               java.lang.String strAlternateIdentifier,
                               java.lang.String strAlternateText,
                               java.lang.String strNameOfAlternateCodingSystem,
                               java.lang.String strCodingSystemVersionID,
                               java.lang.String strAlternateCodingSystemVersionId,
                               java.lang.String strOriginalText,
                               java.lang.String strSecondAlternateIdentifier,
                               java.lang.String strSecondAlternateText,
                               java.lang.String strNameofSecondAlternateCodingSystem,
                               java.lang.String strSecondAlternateCodingSystemVersionID,
                               java.lang.String strCodingSystemOID,
                               java.lang.String strValueSetOID,
                               java.lang.String strValueSetVersionID,
                               java.lang.String strAlternateCodingSystemOID,
                               java.lang.String strAlternateValueSetOID,
                               java.lang.String strAlternateValueSetVersionID,
                               java.lang.String strSecondAlternateCodingSystemOID,
                               java.lang.String strSecondAlternateValueSetOID,
                               java.lang.String strSecondAlternateValueSetVersionID)

      Set the Product Problem. This product problem would exist if a product malfunction could lead to death or serious injury.
      Parameters:
        `strProductProblem` - This field contains the String Value of Product Problem

    - #### setProductProblem

          public void setProductProblem(CWE objproductProblem)

      Set the Product Problem. This product problem would exist if a product malfunction could lead to death or serious injury.
      Parameters:
        `objproductProblem` - Object of Product Problem.

    - #### addProductSerialLotNumber

          public void addProductSerialLotNumber(java.lang.String strProductSerialLotNumber)

      Add the Product Serial Lot Number. This field is an alphanumeric descriptor which identify the specific item or lot of drug.
      Parameters:
        `strProductSerialLotNumber` - This field contains the String Value of Product Serial Lot Number

    - #### addProductSerialLotNumber

          public void addProductSerialLotNumber(ST objproductSerialLotNumber)

      Add the Product Serial Lot Number. This field is an alphanumeric descriptor which identify the specific item or lot of drug.
      Parameters:
        `objproductSerialLotNumber` - Object of Product Serial Lot Number.

    - #### setProductSerialLotNumber

          public void setProductSerialLotNumber(ISingleCollection<ST> objproductSerialLotNumberList)

      Set the Product Serial Lot Number. This field is an alphanumeric descriptor which identify the specific item or lot of drug.
      Parameters:
        `objproductSerialLotNumberList` - List of Product Serial Lot Number.

    - #### setRelatednessAssessment

          public void setRelatednessAssessment(java.lang.String strRelatednessAssessment)

      Set the Relatedness Assessment. This field represents the assessment of relatedness of the product to the event.
      Parameters:
        `strRelatednessAssessment` - This field contains the String Value of Relatedness Assessment

    - #### setRelatednessAssessment

          public void setRelatednessAssessment(ID objrelatednessAssessment)

      Set the Relatedness Assessment. This field represents the assessment of relatedness of the product to the event.
      Parameters:
        `objrelatednessAssessment` - Object of Relatedness Assessment.

    - #### setSingleUseDevice

          public void setSingleUseDevice(java.lang.String strIdentifier,
                                java.lang.String strText,
                                java.lang.String strNameOfCodingSystem,
                                java.lang.String strAlternateIdentifier,
                                java.lang.String strAlternateText,
                                java.lang.String strNameOfAlternateCodingSystem,
                                java.lang.String strCodingSystemVersionID,
                                java.lang.String strAlternateCodingSystemVersionId,
                                java.lang.String strOriginalText,
                                java.lang.String strSecondAlternateIdentifier,
                                java.lang.String strSecondAlternateText,
                                java.lang.String strNameofSecondAlternateCodingSystem,
                                java.lang.String strSecondAlternateCodingSystemVersionID,
                                java.lang.String strCodingSystemOID,
                                java.lang.String strValueSetOID,
                                java.lang.String strValueSetVersionID,
                                java.lang.String strAlternateCodingSystemOID,
                                java.lang.String strAlternateValueSetOID,
                                java.lang.String strAlternateValueSetVersionID,
                                java.lang.String strSecondAlternateCodingSystemOID,
                                java.lang.String strSecondAlternateValueSetOID,
                                java.lang.String strSecondAlternateValueSetVersionID)

      Set the Single Use Device. This field indicates whether the product is designed for a single use or not.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setSingleUseDevice

          public void setSingleUseDevice(CWE objsingleUseDevice)

      Set the Single Use Device. This field indicates whether the product is designed for a single use or not.
      Parameters:
        `objsingleUseDevice` - Object of Single Use Device.

    - #### setTotalDurationOfTherapy

          public void setTotalDurationOfTherapy(java.lang.String strQuantity,
                                       CWE objUnits)

      Set the Total Duration Of Therapy. This field represents the total duration of therapy with product listed.
      Parameters:
        `strQuantity` - Specifies the numeric quantity or amount of an entity.
        `objUnits` - Specifies the units in which the quantity is expressed.

    - #### setTotalDurationOfTherapy

          public void setTotalDurationOfTherapy(CQ objtotalDurationOfTherapy)

      Set the Total Duration Of Therapy. This field represents the total duration of therapy with product listed.
      Parameters:
        `objtotalDurationOfTherapy` - Object of Total Duration Of Therapy.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation checks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails.